// client for JDK 1.2

import org.omg.CORBA.ORB;
import java.io.FileReader;
import java.io.BufferedReader;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NamingContextHelper;

class Client
{
    public static void main(String[] args) {
        try {
            ORB orb = ORB.init(args, null);

            // IORt@Cǂݍ
            BufferedReader in = new BufferedReader(
                new FileReader("../counter.ior"));
            String ncIOR = in.readLine();
            String rcIOR = in.readLine();

            org.omg.CORBA.Object ncRef = orb.string_to_object(ncIOR);
            org.omg.CORBA.Object rcRef = orb.string_to_object(rcIOR);
/*
            org.omg.CORBA.Object nameRef
                = orb.resolve_initial_references("NameService");
            NamingContext naming = NamingContextHelper.narrow(nameRef);

            NameComponent nc = new NameComponent("q.Counter", "");
            NameComponent[] pathNC = { nc };
            org.omg.CORBA.Object ncRef = naming.resolve(pathNC);

            NameComponent rc = new NameComponent("q.ReverseCounter", "");
            NameComponent[] pathRC = { rc };
            org.omg.CORBA.Object rcRef = naming.resolve(pathRC);
*/
            // IuWFNg𓾂
            Counter[] counter = new Counter[2];
            counter[0] = CounterHelper.narrow(ncRef);
            counter[1] = ReverseCounterHelper.narrow(rcRef);

            for (int k = 0; k < 2; k++) {
                System.out.println(counter[k].name());

                for (int i = 0; i < 10; i++) {
                    counter[k].incr();
                    System.out.print(" " + counter[k].value());
                }
                System.out.println(".");

                for (int i = 0; i < 5; i++) {
                    counter[k].decr();
                    System.out.print(" " + counter[k].value());
                }
                System.out.println(".");
            }
        }
        catch (Exception e) {
            e.printStackTrace(System.err);
        }
    }
};
